Page MenuHomePhabricator

API Developer support universal rate limit
Closed, ResolvedPublic

Description

"As an API Developer, I want to support a global rate limit regardless of whether my API is implemented within MediaWiki or in a microservice, so that I can use the best tool for my job."

Optional, since the first API mounted (MW REST) is built inside MediaWiki. It's likely that microservice-based APIs will be coming soon. At the very least, we should not prevent this user story from coming later. Note that this doesn't have to be transparent to the API Developer; it could be handled in the service (or in service-runner framework).

Event Timeline

eprodromou triaged this task as Medium priority.Jun 19 2020, 4:19 PM

I believe this requirement is covered by having the rate limiter in Envoy.

eprodromou reassigned this task from eprodromou to hnowlan.Jul 29 2020, 1:22 PM
Naike reassigned this task from hnowlan to eprodromou.Aug 7 2020, 11:59 AM
Naike added a subscriber: hnowlan.
Pchelolo added a subscriber: Pchelolo.

I have no idea what part of the work does this task cover, but it's done.

This is making sure that the rate limit is across services; not just one service (Feeds, Core, whatever)

Pchelolo closed this task as Resolved.Sep 22 2020, 6:30 PM

The path is not a part of the rate limiter key, so limits are global for everything exposed via the gateway.